<?php
// unlimit time
@set_time_limit(0);

function CheckAbilityOfInstallation() {
  global $db;
  global $MODULE_FOLDER, $TMP_FOLDER, $HTTP_ROOT_PATH, $SUB_FOLDER, $DOCUMENT_ROOT;
  
	$result['Success'] = 1;
	$result['ErrorMessage'] = TOOLS_PATCH_ERROR;
  
  if ( !nc_installer_check_php_version() ) {
    $result['Success'] = 0;
    // error text
    $result['ErrorMessage'] = str_replace("%CURRENT", phpversion(), str_replace("%NEED", "5.1", TOOLS_PATCH_ERROR_UNCORRECT_PHP_VERSION) );
    // return error
    return $result;
  }

	// check if all files are writeable
	$files = file($TMP_FOLDER."files.txt");

	// add check for module files
	$installed_modules = $db->get_results("SELECT `Keyword` FROM `Module`", ARRAY_A);
	if( !empty($installed_modules) ) {
		foreach ($installed_modules as $module) {
			if (file_exists($MODULE_FOLDER.$module['Keyword'])) {
				$module_files = nc_installer_filelist($TMP_FOLDER."modules/".$module['Keyword']);
				foreach ((array)$module_files AS $module_file) {
					$files[] = $SUB_FOLDER.$HTTP_ROOT_PATH."modules/".$module['Keyword']."/".$module_file;
				}
			}
		}
	}
	

	foreach ($files AS $file) {
		$file = $DOCUMENT_ROOT.rtrim($file);
		if (file_exists($file)) {
      // file is not writable
			if ( !is_writable($file) && !@chmod($file, 0777) ) {
				$result['ErrorMessage'] = str_replace("%FILE", $file, TOOLS_PATCH_ERROR_SET_FILEPERM_IN_HTTP_ROOT_PATH);
				$result['Success'] = 0;
			}
		}
		else {
		// check dir
			###if(!$dirname) continue;
			$dirname = dirname($file);
			// find the nearest existing parent directory
			while ( !file_exists($dirname) ) {
				$dirname = preg_replace("!/[^/]+$!", "", $dirname);
				if ( $dirname==$DOCUMENT_ROOT.rtrim($HTTP_ROOT_PATH, "/") ) break;
			}
			// directory is not writable
			if ( !is_writable($dirname) && !@chmod($dirname, 0777) ) {
				$result['ErrorMessage'] = str_replace("%DIR", $dirname, TOOLS_PATCH_ERROR_SET_DIRPERM_IN_HTTP_ROOT_PATH);
				$result['Success'] = 0;
			}
		}
	}

  return $result;
}


/**
 * эта функция выполняется самой первой, но после всех проверок и CheckAbilityOfInstallation()
 *
 * @return array result data
 */
function InstallPatch() {
  global $TMP_FOLDER, $MODULE_FOLDER, $ROOT_FOLDER, $db;

	$TMP_FOLDER = str_replace("#", "/", $TMP_FOLDER);

	$result['Success'] = 1;
	$result['ErrorMessage'] = TOOLS_PATCH_ERROR;

	// SystemID
	$SystemID = $db->get_var("SELECT `SystemID` FROM `Settings`");
	
	// список установленных модулей

  $installed_modules = $db->get_col("SELECT `Keyword` FROM `Module`");
	

	
	foreach ($installed_modules AS $keyword) {
		// Execute SQL, if any
		if ( file_exists($TMP_FOLDER."modules/".$keyword.".sql") ) {
			ExecSQL($TMP_FOLDER."modules/".$keyword.".sql");
		}

		// Create DIR if not exist
		if ( !file_exists($MODULE_FOLDER.$keyword) ) {
			@mkdir($MODULE_FOLDER.$keyword, 0755);
		}

		// Copy all files to modules folder
		nc_installer_copy_all($TMP_FOLDER."modules/".$keyword, $MODULE_FOLDER.$keyword);

		// include script if necessary
		if ( file_exists($TMP_FOLDER."modules/".$keyword.".inc.php") ) {
			include ($TMP_FOLDER."modules/".$keyword.".inc.php");
		}

		// Remove old files
		if( file_exists($TMP_FOLDER."modules/".$keyword.".remove") ) {
			$files_to_remove = file($TMP_FOLDER."modules/".$keyword.".remove");
			foreach ($files_to_remove AS $file) {
				$file = trim($file, "\r\n/");
				if( @is_dir($ROOT_FOLDER.$file) ) {
					@rmdir($ROOT_FOLDER.$file);
				}
				else {
					@unlink($ROOT_FOLDER.$file);
				}
			}
		}

	}
  
  // правка yandex-карт
  $db->query("UPDATE `Widget_Class` SET `Template`='<script src=''http://api-maps.yandex.ru/1.1/index.xml?key=\".\$api_key.\"'' type=''text/javascript''></script>\\n<style type=''text/css''>\\n   #\".\$div_name.\" td{ padding: 0 }\\n   #\".\$div_name.\" table{ width: auto }\\n</style>\\n<div id=''\".\$div_name.\"'' style=''width: \".\$f_width.\"px; height: \".\$f_height.\"px; color:black;''>просмотр карты недоступен</div>\\n\\n<script type=''text/javascript''>\\n    YMaps.jQuery(function () {\\n        var map = new YMaps.Map(YMaps.jQuery(''#\".\$div_name.\"'')[0]);\\n        map.setCenter(new YMaps.GeoPoint(\". \$f_center .\"), \".\$f_scale.\");\\n        map.setType(YMaps.MapType.\". \$map_type .\");\\n\\n        \".(\$f_enableDblClickZoom!=''1'' ? \"map.disableDblClickZoom();\" : \"\").\"\\n        \".(\$f_enableScrollZoom==''1'' ? \"map.enableScrollZoom();\" : \"\").\"\\n        \".(\$f_enableHotKeys==''1'' ? \"map.enableHotKeys();\" : \"\").\"\\n        \".(\$f_enableMiniMap==''1'' ? \"map.addControl(new YMaps.MiniMap());\" : \"\").\"\\n        map.addControl(new YMaps.ToolBar([\".(\$f_enableMove==''1'' ? \"new YMaps.ToolBar.MoveButton(),\" : \"\") . (\$f_enableMagnifier==''1'' ? \"new YMaps.ToolBar.MagnifierButton(),\" : \"\") . (\$f_enableRuler==''1'' ? \"new YMaps.ToolBar.RulerButton()\" : \"\").\"]));\\n        \".(\$f_enableZoomBar==''1'' ? \"map.addControl(new YMaps.Zoom());\" : \"\").\"\\n        \".(\$f_enableZoomBar==''2'' ? \"map.addControl(new YMaps.SmallZoom());\" : \"\").\"\\n        \".(\$f_enableMapType==''1'' ? \"map.addControl(new YMaps.TypeControl([YMaps.MapType.MAP,YMaps.MapType.SATELLITE,YMaps.MapType.HYBRID],[0,1,2]));\" : \"\").\"\\n\\n        var s = new YMaps.Style();\\n        s.lineStyle = new YMaps.LineStyle();\\n        s.lineStyle.strokeWidth = ''3'';\\n        YMaps.Styles.add(''netcat#NormalLine'', s);\\n\\n        \".\$placemarks.\"\\n        \".\$polyline.\"\\n    })</script>\\n', `Settings`='\$api_key = \$f_api_key1 . opt(\$f_api_key2, \"~\".\$f_api_key2) . opt(\$f_api_key3, \"~\".\$f_api_key3) .\\n           opt(\$f_api_key4, \"~\".\$f_api_key4) . opt(\$f_api_key5, \"~\".\$f_api_key5);\\n\$div_name = (\$f_div_name ? \$f_div_name : \"YMapsID\");\\n\$map_type = (\$f_map_type ? \$f_map_type : \"MAP\");\\n\\nif (\$f_placemarks) {\\n  \$placemarks_arr = explode(\"\\\\n\", \$f_placemarks);\\n  \$i = 0;\\n  foreach (\$placemarks_arr as \$mark)\\n    if (\$mark!=\"\") {\\n      \$mark = str_replace(\"\\\\r\", \"\", \$mark);\\n      \$mark_arr = explode(\";\", \$mark);\\n      \$placemarks .= \"var placemark\".\$i.\" = new YMaps.Placemark(new YMaps.GeoPoint(\".\$mark_arr[0].\"));\\\\n\";\\n      if (\$mark_arr[1] != \"\") {\\n        \$placemarks .= \"placemark\".\$i.\".name = ''\".\$mark_arr[1].\"'';\\n        placemark\".\$i.\".setIconContent(''\".\$mark_arr[1].\"'');\";\\n      }\\n      if (\$mark_arr[2] != \"\")\\n        \$placemarks .= \"placemark\".\$i.\".description = ''\".\$mark_arr[2].\"'';\\\\n\";\\n      if (\$mark_arr[3] != \"\")\\n        \$placemarks .= \"placemark\".\$i.\".setOptions({style: ''\".\$mark_arr[3].\"''});\\\\n\";\\n      \$placemarks .= \"map.addOverlay(placemark\".\$i.\");\\\\n\";\\n      \$i++;\\n    }\\n}\\n\\nif (\$f_polyline) {\\n\$f_poly_arr = explode(\"\\\\n\", \$f_polyline);\\n\$i = 0;\\nforeach (\$f_poly_arr as \$poly)\\n  if (\$poly) {\\n  \$polyline .= \"pl\".\$i.\" = new YMaps.Polyline([\";\\n  \$polyline_arr = explode(\";\", \$poly);\\n  foreach (\$polyline_arr as \$mark)\\n    if (\$mark!=\"\")\\n      \$polyline .= \"new YMaps.GeoPoint(\".\$mark.\"),\";\\n  \$polyline .= \"]);\\\\n pl\".\$i.\".setStyle(''netcat#NormalLine'');\\\\n map.addOverlay(pl\".\$i.\");\\\\n\";\\n  \$i++;\\n  }\\n}\\n', `AddForm`='<p>Для использования Яндекс-Карт на вашем сайте, необходимо <a href=''http://api.yandex.ru/maps/form.xml'' target=''_blank''>получить API-ключ</a> и ввести его в следующее поле ввода.<br />\\nДля каждого зеркала сайта (кроме префикса www) требуется создавать отдельный ключ.</p>\\n<font color=''gray''>API-ключ (например, ANpUFEkBAAAAf7jmJwMAHGZHrcKNDsbEqEVjEUtCmufxQMwAAAAAAAAAAAAvVrubVT4btztbduoIgTLAeFILaQ==):</font><br />\\n<input name=''f_api_key1'' size=''50'' value='''' /><br /><br />\\n<font color=''gray''>API-ключ для первого зеркала сайта (необязательно):</font><br />\\n<input name=''f_api_key2'' size=''50'' value='''' /><br /><br />\\n<font color=''gray''>API-ключ для второго зеркала сайта (необязательно):</font><br />\\n<input name=''f_api_key3'' size=''50'' value='''' /><br /><br />\\n<font color=''gray''>API-ключ для третьего зеркала сайта (необязательно):</font><br />\\n<input name=''f_api_key4'' size=''50'' value='''' /><br /><br />\\n<font color=''gray''>API-ключ для четвертого зеркала сайта (необязательно):</font><br />\\n<input name=''f_api_key5'' size=''50'' value='''' /><br /><br />\\n<font color=''gray''>Ширина:</font><br />\\n<input name=''f_width'' size=''50'' value=''400'' /><br /><br />\\n<font color=''gray''>Высота:</font><br />\\n<input name=''f_height'' size=''50'' value=''300'' /><br /><br />\\n<font color=''gray''>Координаты центра карты (можете определить <a href=''http://api.yandex.ru/maps/tools/getlonglat/index.xml'' target=''_blank''>тут</a>):</font><br />\\n<input name=''f_center'' size=''50'' value=''37.617671,55.755768'' /><br /><br />\\n<font color=''gray''>Масштаб карты (можете определить <a href=''http://api.yandex.ru/maps/tools/getlonglat/index.xml'' target=''_blank''>тут</a>):</font><br />\\n<input name=''f_scale'' size=''50'' value=''10'' /><br /><br />\\n<font color=''gray''>Id контейнера div с картой (необязательно):</font><br />\\n<input name=''f_div_name'' size=''50'' value='''' /><br /><br />\\n<font color=''gray''>Тип карты:</font>&nbsp;&nbsp;&nbsp;\\n<select name=''f_map_type''>\\n<option value=''MAP''>Схема</option>\\n<option value=''SATELLITE''>Спутник</option>\\n<option value=''HYBRID''>Гибрид</option>\\n</select><br /><br />\\n<input type=''checkbox'' name=''f_enableDblClickZoom'' value=''1''>\\n<font color=''gray''>Масштабирование двойным щелчком мыши</font><br /><br />\\n<input type=''checkbox'' name=''f_enableScrollZoom'' value=''1''>\\n<font color=''gray''>Масштабирование колесиком мыши</font><br /><br />\\n<input type=''checkbox'' name=''f_enableHotKeys'' value=''1''>\\n<font color=''gray''>Горячие клавиши</font><br /><br />\\n<input type=''checkbox'' name=''f_enableMiniMap'' value=''1''>\\n<font color=''gray''>Мини-карта</font><br /><br />\\n<fieldset>\\n<legend>Тулбар</legend>\\n<input type=''checkbox'' name=''f_enableMove'' value=''1'' checked>\\n<font color=''gray''>Перемещение</font><br /><br />\\n<input type=''checkbox'' name=''f_enableMagnifier'' value=''1'' checked>\\n<font color=''gray''>Лупа</font><br /><br />\\n<input type=''checkbox'' name=''f_enableRuler'' value=''1'' checked>\\n<font color=''gray''>Линейка</font></fieldset><br /><br />\\n<font color=''gray''>Полоска масштабирования:</font>&nbsp;&nbsp;&nbsp;\\n<select name=''f_enableZoomBar''>\\n<option value=''0''>Нет</option>\\n<option value=''1''>Обычная (с ползунком)</option>\\n<option value=''2''>Компактная</option>\\n</select><br /><br />\\n<input type=''checkbox'' name=''f_enableMapType'' value=''1'' checked>\\n<font color=''gray''>Переключатель типа карты</font><br /><br />\\n<font color=''gray''>Координаты, название, описание, стиль меток, разделенные символом &quot;;&quot;, каждая метка описывается на новой строке (необязательно):<br />\\n<i>&nbsp;&nbsp;&nbsp;Пример: 37.609218,55.753559;Москва;Столица Российской Федерации;default#lightbluePoint<br>\\n&nbsp;&nbsp;&nbsp;Координаты можете определить <a href=''http://api.yandex.ru/maps/tools/getlonglat/index.xml'' target=''_blank''>тут</a>, список всех возможных стилей меток находится <a href=''http://api.yandex.ru/maps/jsapi/doc/ref/reference/styles.xml'' target=''_blank''>тут</a>; все поля, кроме координат можно опустить.</i></font><br />\\n<textarea name=''f_placemarks''></textarea><br /><br />\\n<font color=''gray''>Координаты вершин ломаной линии, разделенные символом &quot;;&quot;, каждая ломаная описывается на новой строке (необязательно):<br />\\n<i>&nbsp;&nbsp;&nbsp;Пример: 37.609218,55.753559;37.699553,55.747926<br />\\n&nbsp;&nbsp;&nbsp;Координаты можете определить <a href=''http://api.yandex.ru/maps/tools/getlonglat/index.xml'' target=''_blank''>тут</a></font><br />\\n<textarea name=''f_polyline''></textarea><br /><br />\\n\\n', `EditForm`='<p>Для использования Яндекс-Карт на вашем сайте, необходимо <a href=''http://api.yandex.ru/maps/form.xml'' target=''_blank''>получить API-ключ</a> и ввести его в следующее поле ввода.<br />\\nДля каждого зеркала сайта (кроме префикса www) требуется создавать отдельный ключ.</p>\\n<font color=''gray''>API-ключ:</font><br />\\n<input name=''f_api_key1'' size=''50'' value=''\$f_api_key1'' /><br /><br />\\n<font color=''gray''>API-ключ для первого зеркала сайта (необязательно):</font><br />\\n<input name=''f_api_key2'' size=''50'' value=''\$f_api_key2'' /><br /><br />\\n<font color=''gray''>API-ключ для второго зеркала сайта (необязательно):</font><br />\\n<input name=''f_api_key3'' size=''50'' value=''\$f_api_key3'' /><br /><br />\\n<font color=''gray''>API-ключ для третьего зеркала сайта (необязательно):</font><br />\\n<input name=''f_api_key4'' size=''50'' value=''\$f_api_key4'' /><br /><br />\\n<font color=''gray''>API-ключ для четвертого зеркала сайта (необязательно):</font><br />\\n<input name=''f_api_key5'' size=''50'' value=''\$f_api_key5'' /><br /><br />\\n<font color=''gray''>Ширина:</font><br />\\n<input name=''f_width'' size=''50'' value=''\$f_width'' /><br /><br />\\n<font color=''gray''>Высота:</font><br />\\n<input name=''f_height'' size=''50'' value=''\$f_height'' /><br /><br />\\n<font color=''gray''>Координаты центра карты (можете определить <a href=''http://api.yandex.ru/maps/tools/getlonglat/index.xml'' target=''_blank''>тут</a>):</font><br />\\n<input name=''f_center'' size=''50'' value=''\$f_center'' /><br /><br />\\n<font color=''gray''>Масштаб карты (можете определить <a href=''http://api.yandex.ru/maps/tools/getlonglat/index.xml'' target=''_blank''>тут</a>):</font><br />\\n<input name=''f_scale'' size=''50'' value=''\$f_scale'' /><br /><br />\\n<font color=''gray''>Id контейнера div с картой (необязательно):</font><br />\\n<input name=''f_div_name'' size=''50'' value=''\$f_div_name'' /><br /><br />\\n<font color=''gray''>Тип карты:</font>&nbsp;&nbsp;&nbsp;\\n<select name=''f_map_type''>\\n<option value=''MAP'' \".(\$f_map_type==\"MAP\" ? \"selected\" : \"\").\">Схема</option>\\n<option value=''SATELLITE'' \".(\$f_map_type==\"SATELLITE\" ? \"selected\" : \"\").\">Спутник</option>\\n<option value=''HYBRID'' \".(\$f_map_type==\"HYBRID\" ? \"selected\" : \"\").\">Гибрид</option>\\n</select><br /><br />\\n<input type=''checkbox'' name=''f_enableDblClickZoom'' value=''1'' \".(\$f_enableDblClickZoom==''1'' ? \"checked\" : \"\").\">\\n<font color=''gray''>Масштабирование двойным щелчком мыши</font><br /><br />\\n<input type=''checkbox'' name=''f_enableScrollZoom'' value=''1'' \".(\$f_enableScrollZoom==''1'' ? \"checked\" : \"\").\">\\n<font color=''gray''>Масштабирование колесиком мыши</font><br /><br />\\n<input type=''checkbox'' name=''f_enableHotKeys'' value=''1'' \".(\$f_enableHotKeys==''1'' ? \"checked\" : \"\").\">\\n<font color=''gray''>Горячие клавиши</font><br /><br />\\n<input type=''checkbox'' name=''f_enableMiniMap'' value=''1'' \".(\$f_enableMiniMap==''1'' ? \"checked\" : \"\").\">\\n<font color=''gray''>Мини-карта</font><br /><br />\\n<fieldset>\\n<legend>Тулбар</legend>\\n<input type=''checkbox'' name=''f_enableMove'' value=''1'' \".(\$f_enableMagnifier==''1'' ? \"checked\" : \"\").\">\\n<font color=''gray''>Перемещение</font><br /><br />\\n<input type=''checkbox'' name=''f_enableMagnifier'' value=''1'' \".(\$f_enableMagnifier==''1'' ? \"checked\" : \"\").\">\\n<font color=''gray''>Лупа</font><br /><br />\\n<input type=''checkbox'' name=''f_enableRuler'' value=''1'' \".(\$f_enableRuler==''1'' ? \"checked\" : \"\").\">\\n<font color=''gray''>Линейка</font>\\n</fieldset><br /><br />\\n<font color=''gray''>Полоска масштабирования:</font>&nbsp;&nbsp;&nbsp;\\n<select name=''f_enableZoomBar''>\\n<option value=''0'' \".(\$f_enableZoomBar==\"0\" ? \"selected\" : \"\").\">Нет</option>\\n<option value=''1'' \".(\$f_enableZoomBar==\"1\" ? \"selected\" : \"\").\">Обычная (с ползунком)</option>\\n<option value=''2'' \".(\$f_enableZoomBar==\"2\" ? \"selected\" : \"\").\">Компактная</option>\\n</select><br /><br />\\n<input type=''checkbox'' name=''f_enableMapType'' value=''1'' \".(\$f_enableMapType==''1'' ? \"checked\" : \"\").\">\\n<font color=''gray''>Переключатель типа карты</font><br /><br />\\n<font color=''gray''>Координаты, название, описание, стиль меток, разделенные символом &quot;;&quot;, каждая метка описывается на новой строке (необязательно):<br />\\n<i>&nbsp;&nbsp;&nbsp;Пример: 37.609218,55.753559;Москва;Столица Российской Федерации;default#lightbluePoint<br>\\n&nbsp;&nbsp;&nbsp;Координаты можете определить <a href=''http://api.yandex.ru/maps/tools/getlonglat/index.xml'' target=''_blank''>тут</a>, список всех возможных стилей меток находится <a href=''http://api.yandex.ru/maps/jsapi/doc/ref/reference/styles.xml'' target=''_blank''>тут</a>; все поля, кроме координат можно опустить.</i></font><br />\\n<textarea name=''f_placemarks''>\$f_placemarks</textarea><br /><br />\\n<font color=''gray''>Координаты вершин ломаной линии, разделенные символом &quot;;&quot;, каждая ломаная описывается на новой строке (необязательно):<br />\\n<i>&nbsp;&nbsp;&nbsp;Пример: 37.609218,55.753559;37.699553,55.747926<br />\\n&nbsp;&nbsp;&nbsp;Координаты можете определить <a href=''http://api.yandex.ru/maps/tools/getlonglat/index.xml'' target=''_blank''>тут</a></font><br />\\n<textarea name=''f_polyline''>\$f_polyline</textarea><br /><br />\\n', `LastUpdated`=NOW() WHERE `Keyword`=\"yandexmaps\"");

  $WidgetClassID = $db->get_var("SELECT `Widget_Class_ID` FROM `Widget_Class` WHERE `Keyword`=\"yandexmaps\"");

  if ($WidgetClassID) {
    $db->query("UPDATE `Field` SET `TypeOfData_ID`='3', `Format`='5:60;html:0;br:2;fck:2;bbcode:0;usereditor:0;' WHERE `Field_Name`='placemarks' AND `Widget_Class_ID`='".$WidgetClassID."'");
    $db->query("UPDATE `Field` SET `TypeOfData_ID`='3', `Format`='5:60;html:2;br:2;fck:2;bbcode:0;usereditor:0;' WHERE `Field_Name`='polyline' AND `Widget_Class_ID`='".$WidgetClassID."'");
    $db->query("INSERT INTO `Field` (`Class_ID`, `Field_Name`, `Description`, `TypeOfData_ID`, `Format`, `NotNull`, `Priority`, `DoSearch`, `DefaultState`, `Inheritance`, `System_Table_ID`, `Widget_Class_ID`, `TypeOfEdit_ID`, `Checked`) VALUES (0, 'enableMiniMap', 'Мини-карта', 1, '', 0, 21, 0, '', 0, 0, '".$WidgetClassID."', 1, 1);");
    $FieldID = $db->insert_id;
    $Widgets = $db->get_col("SELECT `Widget_ID` FROM `Widget` WHERE `Widget_Class_ID`='".$WidgetClassID."'");
    if ($Widgets)
      foreach ($Widgets as $WidgetID) {
        if ($FieldID){
          $db->query("INSERT INTO `Widget_Field` (`Widget_ID`, `Field_ID`, `Value`) VALUES ('".$WidgetID."', '".$FieldID."', '')");
        }
        $Fields = $db->get_col("SELECT `Field_ID` FROM `Field` WHERE `Field_Name`='placemarks' AND `Widget_Class_ID`='".$WidgetClassID."'");
        if ($Fields)
          foreach($Fields as $fi) {
            $db->query("UPDATE `Widget_Field` SET `Value`=Replace(`Value`, ':', '\\n') WHERE `Widget_ID`='".$WidgetID."' AND `Field_ID`='".$fi."'");
        }
        
        $Fields = $db->get_col("SELECT `Field_ID` FROM `Field` WHERE `Field_Name`='polyline' AND `Widget_Class_ID`='".$WidgetClassID."'");
        if ($Fields)
          foreach($Fields as $fi) {
            $db->query("UPDATE `Widget_Field` SET `Value`=Replace(`Value`, ':', ';') WHERE `Widget_ID`='".$WidgetID."' AND `Field_ID`='".$fi."'");
        }
    }
    
    
  }

  return $result;
}


function InstallPatchAfterAction() {
  global $Description, $db, $PatchResult, $PatchResultText;
  global $ADMIN_FOLDER, $SUB_FOLDER, $ADMIN_PATH;

	$changelog = nc_patch_changelog();
	if($changelog) {
		if ( !function_exists("AddSystemMessage") ) {
			include ($ADMIN_FOLDER."report/system.inc.php");
		}
		

	
		// AddSystemMessage(message, title), их бы местами поменять *(O_o)*
		###  ($PatchResultText ? $PatchResultText."\r\n" : "") - сколько файлов скопировано и запросов выполнено, без учёта модулей
		$sysmess = AddSystemMessage($changelog, $Description ? $Description : TOOLS_PATCH_INSTALLED);

		// инфоблок о новом системном сообщении
		if($sysmess) {
			nc_print_status( str_replace("%LINK", ($ADMIN_PATH ? $SUB_FOLDER.$ADMIN_PATH : "/netcat/admin/")."report/system.php?SystemMessageID=".$sysmess, TOOLS_PATCH_INFO_SYSTEM_MESSAGE), "info" );
		}
	}
  
  
  


  return true;
}

function nc_installer_check_php_version () {
  // version must be >= 5.1
  if ( preg_match("/^(\d)\.(\d)/is", phpversion(), $matches) ) {
    if ( intval($matches[1].$matches[2]) >= 51 ) return true;
  }
  // version oldest
  return false;
}

function nc_installer_copy_all($from, $to) {

	$from = str_replace("#", "/", $from);
	$to = str_replace("#", "/", $to);

	$dh = @opendir($from);
	if(!$dh) return false;

	while( ( $file = readdir($dh) )!==false ) {
		if($file=="." || $file=="..") continue;
		if( @is_dir($from."/".$file) ) {
			@mkdir($to."/".$file, 0755);
			nc_installer_copy_all($from."/".$file, $to."/".$file);
		}
		else {
			copy($from."/".$file, $to."/".$file);
		}
	}

	closedir($dh);

  return true;
}


function nc_installer_filelist($dir) {

	$dir = str_replace("#", "/", $dir);
	if (!$level) $start_dir = $dir;

	$ret = array();
	// non-existent dir may be passed
	$dh = @opendir($dir); 

	if (!$dh) return false;

	while ( ($file = readdir($dh))!==false ) {
		if ($file=="." || $file=="..") continue;
		if ( is_dir($dir."/".$file) ) {
			$ret = array_merge( $ret, nc_installer_filelist($dir."/".$file) );
		}
		else {
			$ret[] = preg_replace("!^$start_dir/!", "", $dir."/".$file);
		}
	}

	closedir($dh);
	
  return $ret;
}


function nc_copy_dir_r ($from, $to) { 
 global $DIRCHMOD;
 mkdir($to, $DIRCHMOD); 

 if (is_dir($from)) { 
  chdir($from); 
  $handle=opendir('.'); 
  while (($file = readdir($handle))!==false) { 
   if (($file != ".") && ($file != "..")) { 
    if (is_dir($file)) { 
     nc_copy_dir_r  ($from.$file."/", $to.$file."/"); 
     chdir($from); 
    } 
    if (is_file($file)) copy($from.$file, $to.$file);
   } 
  } 
  closedir($handle); 
 } 
}


function nc_deleteDirectory($dir) {
    if (!file_exists($dir)) return true;
    if (!is_dir($dir) || is_link($dir)) return unlink($dir);
        foreach (scandir($dir) as $item) {
            if ($item == '.' || $item == '..') continue;
            if (!deleteDirectory($dir . "/" . $item)) {
                chmod($dir . "/" . $item, 0777);
                if (!deleteDirectory($dir . "/" . $item)) return false;
            };
        }
        return rmdir($dir);
    } 
?>
